.TH MANIPULL 1L
''' $Id: manipull.man,v 3.0.3.2 1993/08/25 17:04:46 ram Exp $
'''
''' $Log: manipull.man,v $
''' Revision 3.0.3.2  1993/08/25  17:04:46  ram
''' patch12: cleanup checkin for RCS 5.6
'''
''' Revision 3.0.3.1  91/01/21  11:34:37  ram
''' 3.0 baseline (ram).
''' 
'''
.SH NAME
manipull \- extract entries out of an existing manifest
.SH SYNOPSIS
.RS
.na
.ti -.5i
.B manipull
[
.BI \-f\| #
] [
.BI \-h\| #
] [
.BI \-i\| name
] [
.B \-m
] [
.BI \-o\| name
] [
.B \-s
] [
.B \-v
] file...
.ad
.RE
.SH DESCRIPTION
.I Manipull
reads an existing ``manifest'' (usually created and maintained by
.IR makekit (1L))
and pulls the indicated entries out of it, making a new manifest.
.PP
A manifest consist of some header lines, followed by a series of lines
that describe the files contained in the shell archives.
Each line looks like this;
.RS
filename\ \ \ spaces\ \ \ optional-digits\ \ \ spaces\ \ \ text
.RE
For more information on the interpretation of the file, see the
.I makekit
documentation.
.PP
The original manifest is read from the standard input.
An alternate input file may be given by using the ``\-i'' option.
The generated manifest will be sent to the standard output.
An alternate output file may be given by using the ``\-o'' option.
The ``\-m'' option is the same as giving the options
\&``-iMANIFEST -oMANIFEST.NEW -h2'' and is commonly used when
reading existing manifests.
.PP
The ``\-f'' option may be necessary if the original manifest
has more than a couple of hundred lines.
The existance of this option can be taken as evidence that the program's
author is lazy.
The ``\-h'' option may be given to have the program skip the
indicated number of lines in the input before beginning parsing.
.PP
After all the options have been read, any remaining arguments are
taken to be a list of files to extract from the manifest.
If a file named on the command line does not appear in the existing
manifest, it is added to the new one, with a placeholder for both
the archive number and the description.
.PP
As it is processing,
.I manipull
normally prints a message to standard error when it adds a file that
isn't in the initial manifest, or when a file in that manifest is
omitted.
These messages may be suppressed by using the ``\-s'' option.
.PP
The ``\-v'' option prints out the current version and exits.
.SH "SEE ALSO"
makekit(1L).
